/*
*  Copyright 2018 by the author. It is protected by applicable copyright laws. This program does not
*  give you or anybody else a right or licence to distribute, modify, copy, compile, create derivatives.
*/
package mcs_epr;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

public class Mcs_epr {
    static String proverName = "cprover_priority";
    static String timeSet = "";
    static String CSEProver = "cse";
    static String combinedProverName = "eprover";
    static String problemFileName = "";
    static String problemPath = "";
    static String problemName = "";
    static int problemFormat = 0;
    static int strategyMode = 0;
    static int runMode = 0; 
    static int versionMode = 1;
    static String outTopFilePath = "";
    static String proofStatisticsFile = "";
    static String problemNameNoSuffixFof = "";
    static String  firstRunTime;
    static String  secondRunTime;
    static boolean equalityFlag = false;
    static private String getAppPath() {
        ClassLoader loader = Mcs_epr.class.getClassLoader();
        String clsName = Mcs_epr.class.getName() + ".class";
        Package pack = Mcs_epr.class.getPackage();
        String path = "";
        if(pack != null){
            String packName = pack.getName();
            clsName = clsName.substring(packName.length()+1);
            if(packName.indexOf(".")<0){
                path = packName + "/";
            }
            else{
                int start =0,end =0;
                end =packName.indexOf(".");
                while(end != -1){
                    path = path + packName.substring(start, end) + "/";
                    start = end +1;
                    end = packName.indexOf(".",start);
                }
                path = path + packName.substring(start) + "/";
            }
        }
        
        String realPath ;
        realPath = Mcs_epr.class.getClassLoader().getResource(path + clsName).getPath();
        int pos = realPath.indexOf("file:");
        if(pos > -1) 
            realPath = realPath.substring(pos + 5);
        pos = realPath.indexOf(path + clsName);
        realPath = realPath.substring(0,pos -1 );
        if(realPath.endsWith("!"))
            realPath = realPath.substring(0, realPath.lastIndexOf("/"));
        try {
            realPath = java.net.URLDecoder.decode(realPath, "UTF-8");
        } catch (Exception e) {
            return "";
        }
        return realPath;
    }
    private void createDir(String dirName)
    {
        File dir = new File(dirName);
        if(dir.exists()){
            
            return; 
        }
        dir.mkdirs();
    }
    static private void CreateDirButDel(String dirName){
        File file = new File(dirName);
        if (!file.exists() || !file.isDirectory()) {
            file.mkdir();
        }
        else{
            File[] files = file.listFiles();
            for (int i = 0; i < files.length; i++) {
                File tmp = files[i];
                if (tmp.isDirectory()) {
                    deleteDir(tmp);
                }
                else
                    tmp.delete();
            }
        }
    }
    static private void deleteDir(File dir){
        if(dir.isDirectory()){
            String[] children = dir.list();
            for(int i=0; i<children.length; ++i){
                deleteDir(new File(dir,children[i]));
            }
        }
        dir.delete();
    }
    static private void insertContext(String context, String filePath) {
        FileWriter fw = null;
        try {
            fw = new FileWriter(filePath, true);
            fw.write(context + "\n");
            fw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    public static StringBuilder vampireOrELitConver(String strLit) {
        if (strLit.isEmpty()) {
            return null;
        }
        StringBuilder sb = new StringBuilder();
        int iPos = 0;
        char[] str = strLit.toCharArray();
        boolean isNav = (str[iPos] == '~');
        if (isNav) {
            ++iPos;
        }
        boolean isEqn = false;
        if (str[iPos] == 'E') 
        {
            iPos = strLit.indexOf('(', iPos) + 1;
            char ch = str[iPos];
            if (ch == 'f') 
            {
                int iBracket = 0;
                while (iPos < str.length) {
                    switch (ch) {
                        case '(':
                            ++iBracket;
                            sb.append(ch);
                            break;
                        case ')':
                            --iBracket;
                            sb.append(ch);
                            if (iBracket < 0) {
                                return null;
                            }
                            if (iBracket == 0) {
                                sb.append(isNav ? " != " : " = ");
                                isEqn = true;
                            }
                            break;
                        case 'P':
                            sb.append('p');
                            break;
                        case 'x':
                            sb.append('X');
                            break;
                        case 'a':
                            sb.append('c');
                            break;
                        default:
                            sb.append(ch);
                            break;
                    }

                    ++iPos;
                    ch = str[iPos];
                    if (isEqn) {
                        break;
                    }
                }
            } else {
                while (ch != ',') {
                    switch (ch) {
                        case 'x':
                            sb.append('X');
                            break;
                        case 'a':
                            sb.append('c');
                            break;
                        default:
                            sb.append(ch);
                            break;
                    }

                    ch = str[++iPos];
                }
                sb.append(isNav ? " != " : " = ");
                isEqn = true;
            }
            ++iPos;
        }
        if (!isEqn && isNav) {
            sb.append('~');
        }
        for (; iPos < str.length; ++iPos) {
            boolean isbreak = false;
            char ch = str[iPos];
            switch (ch) {
                case 'P':
                    sb.append('p');
                    break;
                case 'x':
                    sb.append('X');
                    break;
                case 'a':
                    sb.append('c');
                    break;
                case '|':
                    isbreak = true;
                    break;
                default:
                    sb.append(ch);
                    break;
            }
            if (isbreak) {
                break;
            }
        }
        if (isEqn) 
        {
            return sb.deleteCharAt(sb.length() - 1);
        }
        return sb;
    }
    static public StringBuilder vampireOrEClaConver(String strCla, boolean isAxiom, int claId) {
        if (strCla.isEmpty()) {
            return null;
        }
        boolean goalFlag = false;
        if (strCla.contains("GOAL")) {
            goalFlag = true;
        }
        claId = Integer.parseInt(strCla.substring(strCla.indexOf("[") + 1, strCla.indexOf("]")));
        strCla = strCla.substring(strCla.indexOf("]") + 1);
        
        StringBuilder result = new StringBuilder();
        if (isAxiom) {
            result.append(String.format("cnf(clause_%d,axiom,\n ( ", claId));
        } else {
            if (goalFlag) {
                result.append(String.format("cnf(clause_%d,negated_conjecture,\n ( ", claId));
            } else {
                result.append(String.format("cnf(clause_%d,plain,\n ( ", claId));
            }
        }
        String[] sLits = strCla.split("\\+");
        if (sLits.length == 0) {
            return null;
        }
        for (int i = 0; i < sLits.length; ++i) {
            result.append(vampireOrELitConver(sLits[i]));
            if (i < sLits.length - 1) {
                result.append(" | ");
            }
        }
        result.append(")).\n");
        return result;
    }
    static private void convertProblemFormat(String theoremPathOrg, String outFile){
        boolean isAxiom = false;
        int count = 0;
        int axiomCount = 0;
        StringBuilder result = new StringBuilder();
        try {
            BufferedReader br = new BufferedReader(new FileReader(theoremPathOrg));
            BufferedWriter bw = new BufferedWriter(new FileWriter(outFile, true));
            String tmp = br.readLine();
            if (tmp.contains("等词公理")) {
                axiomCount = Integer.parseInt(tmp.substring(tmp.lastIndexOf(":") + 1));
                while (true) {
                    tmp = br.readLine();
                    if (tmp == null) {
                        break;
                    }
                    if (tmp.isEmpty()) {
                        continue;
                    }
                    ++count;
                    if (count <= axiomCount) {
                        isAxiom = true;
                    } else {
                        isAxiom = false;
                    }
                    result.append(new String(vampireOrEClaConver(tmp, isAxiom, count)));
                }
            } else {
                while (tmp != null) {
                    if (tmp.isEmpty() == false) {
                        ++count;
                        if (count <= axiomCount) {
                            isAxiom = true;
                        } else {
                            isAxiom = false;
                        }
                        result.append(new String(vampireOrEClaConver(tmp, isAxiom, count)));
                    }
                    tmp = br.readLine();
                }
            }
            bw.append(result.toString());
            bw.flush();
            bw.close();
            br.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
        
    }
    static public boolean resRFindStr(ArrayList<String> resR, String str) {
        if (resR.isEmpty()) {
            return false;
        }
        for (int i = 0; i < resR.size(); ++i) {
            if (resR.get(i).equals(str)) {
                return true;
            }
        }
        return false;
    }
    
    static public void readFofFile(String outFileName){
        try {
            String sourceLine;
            BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(outFileName), "UTF8"));
            while ((sourceLine = br.readLine()) != null) {
                if(sourceLine.contains("=")){
                    equalityFlag = true;
                    break;
                }
            }
            br.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    public static void main(String[] args) {
        boolean submit = true;
        if(submit){
            timeSet = args[0];
            problemFileName = args[1];
            
        }
        else{
            proverName = args[0];
            problemFileName = args[1]; 
        }
        boolean fileParam = false;
        if(((new File(problemFileName)).exists()) && ((new File(problemFileName)).isDirectory())){
            problemPath = problemFileName;
        }
        else if(((new File(problemFileName)).exists()) && !((new File(problemFileName)).isDirectory())){
            problemPath = problemFileName;
            fileParam = true;
        }
        else if(problemFileName.contains(File.separator)){
            problemFileName = problemFileName.substring(0, problemFileName.lastIndexOf(File.separator));
            problemPath = getAppPath() + File.separator + problemFileName;
        }
        else{
            problemPath = getAppPath() + File.separator + problemFileName;
        }
        if(submit){
            problemFormat = 0;
            strategyMode = 1;
            runMode = 4;
            versionMode = 1;
        }
        else{
            problemFormat = Integer.parseInt(args[2]);
            strategyMode = Integer.parseInt(args[3]);
            runMode = Integer.parseInt(args[4]);
            versionMode = Integer.parseInt(args[5]);
        }
        
        outTopFilePath = getAppPath() + File.separator + "output";
        CreateDirButDel(outTopFilePath);
        proofStatisticsFile = getAppPath() + File.separator + "proofStatistics.txt";
        if(!submit){
            File statisticFile = new File(proofStatisticsFile);
            if(statisticFile.exists()){
                statisticFile.delete();
            }
        }
        if(runMode == 4){
            if(fileParam){
                String usedTime = "";
                problemName = problemPath.substring(problemPath.lastIndexOf(File.separator) + 1);
                System.out.println("start to proof:" + problemName);
                String problemNameNoSuffix = problemName.substring(0, problemName.lastIndexOf("."));
                problemNameNoSuffixFof = problemNameNoSuffix;
                String workPath = outTopFilePath + File.separator + problemNameNoSuffix;
                String ourWorkPath = "";
                String combinedRunCmd;
                String[] cmdProc = {"/bin/sh", "-c", combinedRunCmd};
                boolean outFlag = false;
                boolean outControl = false;
                try {
                    String outStream = "";
                    Process pro = Runtime.getRuntime().exec(cmdProc);
                    BufferedReader bufferedReaderPro = new BufferedReader(new InputStreamReader(pro.getInputStream()));
                    String linePro = "";
                    while ((linePro = bufferedReaderPro.readLine()) != null) {
                        if(outControl){
                                outStream += linePro + "\n";
                            }
                        }
                        if(linePro.contains("Proof found!")) {
                            outStream += "% Version  : CSE_E---1.1\n";
                            outStream += "% Problem  : " + problemName + "\n";
                            if(linePro.startsWith("#")){
                                outStream += "%" + linePro.substring(1) + "\n";
                            }
                            else
                                outStream += linePro + "\n";
                            outFlag = true;
                            outControl = true;
                        }
                        else if(linePro.contains("SZS output end CNFRefutation")) {
                            outControl = false;
                        }
                        else if(linePro.contains("User time")) {
                            outControl = true;
                            outStream += "%" + linePro.substring(1) + "\n";
                        }
                        else if(linePro.contains("Total time")) {
                            outControl = false;                     
                            usedTime = linePro.substring(linePro.indexOf(":") + 1);
                            usedTime = usedTime.substring(0, usedTime.indexOf("s")).trim();
                        }
                    }
                    pro.waitFor();
                    bufferedReaderPro.close();
                    if (outFlag) {
                        String outFile = outTopFilePath + File.separator + problemNameNoSuffix;
                        CreateDirButDel(outFile);
                        String outFileName = outTopFilePath + File.separator + problemNameNoSuffix + File.separator + problemNameNoSuffix + ".out";
                        BufferedWriter bw = new BufferedWriter(new FileWriter(outFileName, true));
                        bw.append(outStream);
                        bw.flush();
                        bw.close();
                        System.out.println(outStream);
                        String proofStatisticsInfo = problemNameNoSuffix + ":" + usedTime;
                        insertContext(proofStatisticsInfo, proofStatisticsFile);
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
                if (!outFlag) {
                    String runCSECmd;
                    String[] cmdCSEProc = {"/bin/sh", "-c", runCSECmd};
                    try {
                        String outStream = "";
                        Process pro = Runtime.getRuntime().exec(cmdCSEProc);
                        BufferedReader bufferedReaderPro = new BufferedReader(new InputStreamReader(pro.getInputStream()));
                        String linePro = "";
                        while ((linePro = bufferedReaderPro.readLine()) != null) {
                            outStream += linePro + "\n";
                            if (linePro.contains("output start Proof")) {
                                outFlag = true;
                            }
                        }
                        pro.waitFor();
                        bufferedReaderPro.close();
                        if (outFlag) {
                            System.out.println(outStream);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                    if(!outFlag){
                        equalityFlag = false;
                        String cnfFilePathF = outTopFilePath + File.separator + "tptp";
                        File tptpFile = new File(cnfFilePathF);
                        if (tptpFile.exists()) {
                            File filesFind[] = tptpFile.listFiles();
                            for (int m = 0; m < filesFind.length; ++m) {
                                String name = filesFind[m].getName();
                                String postFix = name.substring(name.lastIndexOf(".") + 1);
                                if (postFix.endsWith("tptp") == false) {
                                    continue;
                                }
                                String nameFof = " ";
                                if(name.contains("+"))
                                    nameFof = name.substring(0, name.lastIndexOf("+"));
                                if (nameFof.contains("+"))
                                    nameFof = nameFof.substring(0, nameFof.lastIndexOf("+"));
                                if (nameFof.equals(problemNameNoSuffix)) {
                                    problemNameNoSuffix = name.substring(0, name.lastIndexOf("."));
                                    break;
                                }
                            }
                        }
                        ArrayList<String> usedClaId = new ArrayList<String>();
                        ourWorkPath = outTopFilePath + File.separator + problemNameNoSuffix;
                        String outResFileName = outTopFilePath + File.separator + problemNameNoSuffix + File.separator + problemNameNoSuffix + ".res";
                        if ((new File(outResFileName).exists())) {
                            String convertFileName = outTopFilePath + File.separator + problemNameNoSuffix + File.separator + problemNameNoSuffix + ".cnf";
                            convertProblemFormat(outResFileName, convertFileName);
                            int leftTime = 300 - Integer.parseInt(firstRunTime) - Integer.parseInt(secondRunTime);
                            String combinedProverRunCmd;
                            String[] cmdProverProc = {"/bin/sh", "-c", combinedProverRunCmd};
                            try {
                                String outStream = "";
                                Process pro = Runtime.getRuntime().exec(cmdProverProc);
                                BufferedReader bufferedReaderPro = new BufferedReader(new InputStreamReader(pro.getInputStream()));
                                String linePro = "";
                                while ((linePro = bufferedReaderPro.readLine()) != null) {
                                    if (outFlag) {
                                        if (linePro.contains("Total time")) {
                                            usedTime = linePro.substring(linePro.indexOf(":") + 1);
                                            usedTime = usedTime.substring(0, usedTime.indexOf("s")).trim();
                                        }
                                        if (linePro.contains("#")) {
                                            continue;
                                        }
                                        
                                        outStream += linePro + "\n";
                                    }
                                    if (linePro.contains("Proof found!")) {
                                        
                                        outFlag = true;
                                    }
                                    if (outFlag) {
                                        if (linePro.contains("cnf(clause_")) {                                           
                                            String clauseId = linePro.substring(linePro.indexOf("cnf(clause_") + "cnf(clause_".length(), linePro.indexOf(","));
                                            usedClaId.add(clauseId);
                                        }
                                    }
                                }
                                pro.waitFor();
                                bufferedReaderPro.close();
                                if (outFlag) {
                                    ArrayList<String> allPathOut = new ArrayList<String>();
                                    Map<Integer, ArrayList<Integer>> pathOut = new HashMap<Integer, ArrayList<Integer>>();
                                    double totalTime = Double.parseDouble(firstRunTime) + Double.parseDouble(secondRunTime) + Double.parseDouble(usedTime);
                                    String outFile = outTopFilePath + File.separator + problemNameNoSuffix;
                                    String outFileName = outTopFilePath + File.separator + problemNameNoSuffix + File.separator + problemNameNoSuffix + ".out";
                                    String validOutFileName = outTopFilePath + File.separator + problemNameNoSuffix + File.separator + problemNameNoSuffix + ".valid";
                                    String readLine = "";
                                    String rId = "";
                                    String clasId = "";
                                    BufferedReader bread = new BufferedReader(new InputStreamReader(new FileInputStream(outFileName), "UTF8"));
                                    while ((readLine = bread.readLine()) != null) {
                                        allPathOut.add(readLine + "\n");
                                        if (readLine.contains("cnf")) {
                                            rId = readLine.substring(readLine.indexOf("(") + 1, readLine.indexOf(","));
                                        } else if (readLine.contains("inference")) {
                                            clasId = readLine.substring(readLine.lastIndexOf("[") + 1, readLine.lastIndexOf("]"));
                                        }
                                        if (!rId.isEmpty() && !clasId.isEmpty()) {
                                            int key = Integer.parseInt(rId);
                                            if (clasId.contains(",")) {
                                                String tmpString[] = clasId.split(",");
                                                ArrayList<Integer> ins = new ArrayList<Integer>();
                                                for (int ind = 0; ind < tmpString.length; ++ind) {
                                                    ins.add(Integer.parseInt(tmpString[ind]));
                                                }
                                                pathOut.put(key, ins);
                                            } else {
                                                ArrayList<Integer> ins = new ArrayList<Integer>();
                                                ins.add(Integer.parseInt(clasId));
                                                pathOut.put(key, ins);
                                            }
                                            rId = "";
                                            clasId = "";
                                        }
                                    }
                                    bread.close();
                                    int clauseSetSize = 0;
                                    String preFile = outTopFilePath + File.separator + problemNameNoSuffix + ".pre";
                                    BufferedReader bPre = new BufferedReader(new InputStreamReader(new FileInputStream(preFile), "UTF8"));
                                    while ((readLine = bPre.readLine()) != null) {
                                        if (readLine.contains("ClaNum")) {
                                            String clauseSetSizeStr = readLine.substring(readLine.indexOf(":") + 1, readLine.indexOf("("));
                                            clauseSetSize = Integer.parseInt(clauseSetSizeStr);
                                            break;
                                        }

                                    }
                                    bPre.close();
                                    if (usedClaId.size() > 0) {
                                        for (int ind = 0; ind < usedClaId.size(); ++ind) {
                                            int usedId = Integer.parseInt(usedClaId.get(ind));
                                            if (usedId > clauseSetSize) {
                                                for (int inp = 0; inp < pathOut.get(usedId).size(); ++inp) {
                                                    int claId = pathOut.get(usedId).get(inp);
                                                    if (claId > clauseSetSize) {
                                                        if (resRFindStr(usedClaId, claId + "") == false) {
                                                            usedClaId.add(claId + "");
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if(usedClaId.size()>0){
                                        String usedClauseFile = outTopFilePath + File.separator + problemNameNoSuffix + File.separator + "usedClause.res";
                                        BufferedWriter bw1 = new BufferedWriter(new FileWriter(usedClauseFile, true));
                                        for(int n=0; n<usedClaId.size(); ++n){
                                            bw1.append(usedClaId.get(n) + "\n");
                                        }
                                        bw1.close();
                                    }                     
                                    String sourceLine = "";
                                    String saveScsClaLine = "";
                                    boolean permitOutput = false;
                                    BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(outFileName), "UTF8"));
                                    BufferedWriter bw = new BufferedWriter(new FileWriter(validOutFileName, true));
                                    while ((sourceLine = br.readLine()) != null) {
                                        if (sourceLine.contains("%")) {
                                            saveScsClaLine += sourceLine + "\n";
                                        } else if (sourceLine.contains("cnf")) {
                                            String claId = sourceLine.substring(sourceLine.indexOf("(") + 1, sourceLine.indexOf(","));
                                            if (resRFindStr(usedClaId, claId)) {
                                                saveScsClaLine += sourceLine + "\n";
                                                permitOutput = true;
                                                continue;
                                            } else {
                                                permitOutput = false;
                                            }
                                        }
                                        if (permitOutput) {
                                            saveScsClaLine += sourceLine + "\n";
                                        }
                                    }
                                    br.close();
                                    bw.append(saveScsClaLine);
                                    bw.append(outStream);
                                    bw.flush();
                                    bw.close();
                                    System.out.println("%-------------------------------------------");
                                    System.out.println("% File        :CSE_E---1.1");
                                    System.out.println("% Problem     :" + problemName);
                                    System.out.println("% Transform   :fof cnf");
                                    System.out.println("% Format      :tptp:raw");
                                    System.out.println("% Command     :java -jar mcs_epr.jar CSE_E 0 0 2 1 %d %s");
                                    System.out.println("\n");
                                    System.out.println("% Result      :Theorem " + totalTime + "s");
                                    System.out.println("% Output      :CNFRefutation " + totalTime + "s");
                                    System.out.println("\n");
                                    Scanner scFof = new Scanner(problemPath);
                                    while (scFof.hasNextLine()) {
                                        System.out.println(scFof.nextLine());
                                    }
                                    scFof.close();
                                    System.out.println("%-------------------------------------------");
                                    System.out.println("% Proof found");
                                    System.out.println("% SZS status Theorem for " + problemName);
                                    System.out.println("% SZS output start Proof");
                                    String cnfFile = outTopFilePath + File.separator + problemNameNoSuffix + ".pre";
                                    File cnfFilePath = new File(cnfFile);
                                    if (cnfFilePath.exists()) {
                                        Scanner scCnf = new Scanner(cnfFilePath);
                                        while (scCnf.hasNextLine()) {
                                            System.out.println(scCnf.nextLine());
                                        }
                                        scCnf.close();
                                    }
                                    System.out.println("%-------------------------------------------");
                                    
                                    Scanner scOutput = new Scanner(new File(validOutFileName));
                                    while (scOutput.hasNextLine()) {
                                        System.out.println(scOutput.nextLine());
                                    }
                                    scOutput.close();
                                    System.out.println("% SZS output end Proof");
                                    System.out.println("% Total time :" + totalTime + "s");
                                    
                                    String proofStatisticsInfo = problemNameNoSuffixFof + ":" + totalTime;
                                    insertContext(proofStatisticsInfo, proofStatisticsFile);

                                } else {
                                    String proofStatisticsInfo = problemNameNoSuffixFof + " :TMO‑Non";
                                    insertContext(proofStatisticsInfo, proofStatisticsFile);
                                    File file = new File(workPath);
                                    if(file.exists()){
                                        deleteDir(file);
                                    }
                                    File fileOur = new File(ourWorkPath);
                                    if (fileOur.exists()) {
                                        deleteDir(fileOur);
                                    }
                                    System.out.println("TMO‑Non");
                                }
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        } else {
                            String proofStatisticsInfo = problemNameNoSuffixFof + " :TMO‑Non";
                            insertContext(proofStatisticsInfo, proofStatisticsFile);
                            File file = new File(workPath);
                            if (file.exists()) {
                                deleteDir(file);
                            }
                            File fileOur = new File(ourWorkPath);
                            if (fileOur.exists()) {
                                deleteDir(fileOur);
                            }
                            System.out.println("TMO‑Non");
                        }
                    }

                }
            }
            else{
                File files[] = (new File(problemPath)).listFiles();
                if ((files == null) || (files.length == 0)) {
                    System.out.println("proof file is empty!");
                } else {
                    for (int i = 0; i < files.length; ++i) {
                        if (files[i].isDirectory()) {
                            continue;
                        } else {
                            String usedTime = "";
                            problemName = files[i].getName();
                            System.out.println("start to proof:" + problemName);
                            String problemNameNoSuffix = problemName.substring(0, problemName.lastIndexOf("."));
                            problemNameNoSuffixFof = problemNameNoSuffix;
                            String workPath = outTopFilePath + File.separator + problemNameNoSuffix;
                            String ourWorkPath = "";
                            String combinedRunCmd;
                            String[] cmdProc = {"/bin/sh", "-c", combinedRunCmd};
                            boolean outFlag = false;
                            boolean outControl = false;
                            try {
                                String outStream = "";
                                Process pro = Runtime.getRuntime().exec(cmdProc);
                                BufferedReader bufferedReaderPro = new BufferedReader(new InputStreamReader(pro.getInputStream()));
                                String linePro = "";
                                while ((linePro = bufferedReaderPro.readLine()) != null) {
                                    if (outControl) {
                                            outStream += linePro + "\n";
                                        }
                                    }
                                    if (linePro.contains("Proof found!")) {
                                        outStream += "% Version  : CSE_E---1.1\n";
                                        outStream += "% Problem  : " + problemName + "\n";
                                        if (linePro.startsWith("#")) {
                                            outStream += "%" + linePro.substring(1) + "\n";
                                        } else {
                                            outStream += linePro + "\n";
                                        }
                                        outFlag = true;
                                        outControl = true;
                                    } else if (linePro.contains("SZS output end CNFRefutation")) {
                                        outControl = false;
                                    } else if (linePro.contains("User time")) {
                                        outControl = true;
                                        outStream += "%" + linePro.substring(1) + "\n";
                                    } else if (linePro.contains("Total time")) {
                                        outControl = false;
                                        usedTime = linePro.substring(linePro.indexOf(":") + 1);
                                        usedTime = usedTime.substring(0, usedTime.indexOf("s")).trim();
                                    }
                                }
                                pro.waitFor();
                                bufferedReaderPro.close();
                                if (outFlag) {
                                    String outFile = outTopFilePath + File.separator + problemNameNoSuffix;
                                    CreateDirButDel(outFile);
                                    String outFileName = outTopFilePath + File.separator + problemNameNoSuffix + File.separator + problemNameNoSuffix + ".out";
                                    BufferedWriter bw = new BufferedWriter(new FileWriter(outFileName, true));
                                    bw.append(outStream);
                                    bw.flush();
                                    bw.close();
                                    System.out.println(outStream);
                                    String proofStatisticsInfo = problemNameNoSuffix + ":" + usedTime;
                                    insertContext(proofStatisticsInfo, proofStatisticsFile);
                                    continue;
                                }
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                            if (!outFlag) {
                                String runCSECmd;
                                String[] cmdCSEProc = {"/bin/sh", "-c", runCSECmd};
                                try {
                                    String outStream = "";
                                    Process pro = Runtime.getRuntime().exec(cmdCSEProc);
                                    BufferedReader bufferedReaderPro = new BufferedReader(new InputStreamReader(pro.getInputStream()));
                                    String linePro = "";
                                    while ((linePro = bufferedReaderPro.readLine()) != null) {
                                        outStream += linePro + "\n";
                                        if (linePro.contains("output start Proof")) {
                                            outFlag = true;
                                        }
                                    }
                                    pro.waitFor();
                                    bufferedReaderPro.close();
                                    if (outFlag) {
                                        System.out.println(outStream);
                                        continue;
                                    }
                                } catch (Exception e) {
                                    e.printStackTrace();
                                }
                                if (!outFlag) {
                                    equalityFlag = false;
                                    String cnfFilePathF = outTopFilePath + File.separator + "tptp";
                                    File tptpFile = new File(cnfFilePathF);
                                    if(tptpFile.exists()){
                                        File filesFind[] = tptpFile.listFiles();
                                        for (int m = 0; m < filesFind.length; ++m) {
                                            String name = filesFind[m].getName();
                                            String postFix = name.substring(name.lastIndexOf(".") + 1);
                                            if (postFix.endsWith("tptp") == false) {
                                                continue;
                                            }
                                            String nameFof = " ";
                                            if(name.contains("+"))
                                                nameFof = name.substring(0, name.lastIndexOf("+"));
                                            if(nameFof.contains("+"))
                                                nameFof = nameFof.substring(0, nameFof.lastIndexOf("+"));
                                           
                                            if (nameFof.equals(problemNameNoSuffix)) {
                                                problemNameNoSuffix = name.substring(0, name.lastIndexOf("."));
                                                break;
                                            }
                                        }
                                    }
                                    ourWorkPath = outTopFilePath + File.separator + problemNameNoSuffix;
                                    ArrayList<String> usedClaId = new ArrayList<String>();
                                    String outResFileName = outTopFilePath + File.separator + problemNameNoSuffix + File.separator + problemNameNoSuffix + ".res";
                                    if ((new File(outResFileName).exists())) {
                                        String convertFileName = outTopFilePath + File.separator + problemNameNoSuffix + File.separator + problemNameNoSuffix + ".cnf";
                                        convertProblemFormat(outResFileName, convertFileName);
                                        int leftTime = 300 - Integer.parseInt(firstRunTime) - Integer.parseInt(secondRunTime);
                                        String combinedProverRunCmd;
                                        String[] cmdProverProc = {"/bin/sh", "-c", combinedProverRunCmd};
                                        try {
                                            String outStream = "";
                                            Process pro = Runtime.getRuntime().exec(cmdProverProc);
                                            BufferedReader bufferedReaderPro = new BufferedReader(new InputStreamReader(pro.getInputStream()));
                                            String linePro = "";
                                            while ((linePro = bufferedReaderPro.readLine()) != null) {
                                                if (outFlag) {
                                                    if (linePro.contains("Total time")) {
                                                        usedTime = linePro.substring(linePro.indexOf(":") + 1);
                                                        usedTime = usedTime.substring(0, usedTime.indexOf("s")).trim();
                                                    }
                                                    if (linePro.contains("#")) {
                                                        continue;
                                                    }
                                                    outStream += linePro + "\n";
                                                }
                                                if (linePro.contains("Proof found!")) {
                                                    outFlag = true;
                                                }
                                                if (outFlag) {
                                                    if (linePro.contains("cnf(clause_")) {
                                                        String clauseId = linePro.substring(linePro.indexOf("cnf(clause_") + "cnf(clause_".length(), linePro.indexOf(","));
                                                        usedClaId.add(clauseId);
                                                    }
                                                }
                                            }
                                            pro.waitFor();
                                            bufferedReaderPro.close(); 
                                            if (outFlag) {
                                                ArrayList<String> allPathOut = new ArrayList<String>();
                                                Map<Integer,ArrayList<Integer>> pathOut = new HashMap<Integer,ArrayList<Integer>>();
                                                double totalTime = Double.parseDouble(firstRunTime) + Double.parseDouble(secondRunTime) + Double.parseDouble(usedTime);
                                                String outFile = outTopFilePath + File.separator + problemNameNoSuffix;
                                                String outFileName = outTopFilePath + File.separator + problemNameNoSuffix + File.separator + problemNameNoSuffix + ".out";
                                                String validOutFileName = outTopFilePath + File.separator + problemNameNoSuffix + File.separator + problemNameNoSuffix + ".valid";
                                                String readLine = "";
                                                String rId = "";
                                                String clasId = "";
                                                BufferedReader bread = new BufferedReader(new InputStreamReader(new FileInputStream(outFileName), "UTF8"));
                                                while ((readLine = bread.readLine()) != null) {
                                                    allPathOut.add(readLine + "\n");
                                                    if(readLine.contains("cnf")){
                                                        rId = readLine.substring(readLine.indexOf("(") + 1, readLine.indexOf(","));
                                                    }
                                                    else if(readLine.contains("inference")){
                                                        clasId = readLine.substring(readLine.lastIndexOf("[") + 1, readLine.lastIndexOf("]"));
                                                    }
                                                    if(!rId.isEmpty() && !clasId.isEmpty()){
                                                        int key = Integer.parseInt(rId);
                                                        if(clasId.contains(",")){
                                                            String tmpString[] = clasId.split(",");
                                                            ArrayList<Integer> ins = new ArrayList<Integer>();
                                                            for(int ind=0; ind<tmpString.length; ++ind){
                                                                ins.add(Integer.parseInt(tmpString[ind]));
                                                            }
                                                            pathOut.put(key, ins);
                                                        }
                                                        else{
                                                            ArrayList<Integer> ins = new ArrayList<Integer>();
                                                            ins.add(Integer.parseInt(clasId));
                                                            pathOut.put(key, ins);
                                                        }
                                                        rId = "";
                                                        clasId = "";
                                                    }
                                                }
                                                bread.close();
                                                int clauseSetSize = 0;
                                                String preFile = outTopFilePath + File.separator + problemNameNoSuffix + ".pre";
                                                BufferedReader bPre = new BufferedReader(new InputStreamReader(new FileInputStream(preFile), "UTF8"));
                                                while ((readLine = bPre.readLine()) != null) {
                                                    if(readLine.contains("ClaNum")){
                                                        String clauseSetSizeStr = readLine.substring(readLine.indexOf(":") + 1, readLine.indexOf("("));
                                                        clauseSetSize = Integer.parseInt(clauseSetSizeStr);
                                                        break;
                                                    }
                                                }
                                                bPre.close();
                                                if(usedClaId.size() > 0){
                                                    for(int ind = 0; ind < usedClaId.size(); ++ind ){
                                                        int usedId = Integer.parseInt(usedClaId.get(ind));
                                                        if(usedId > clauseSetSize){
                                                            ArrayList<Integer> tmp = pathOut.get(usedId);
                                                            for(int inp = 0; inp <tmp.size(); ++inp){
                                                                int claId = tmp.get(inp);
                                                                if(claId > clauseSetSize){
                                                                    if(resRFindStr(usedClaId, claId + "") == false){
                                                                        usedClaId.add(claId + "");
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                                if(usedClaId.size() > 0) {
                                                    String usedClauseFile = outTopFilePath + File.separator + problemNameNoSuffix + File.separator + "usedClause.res";
                                                    BufferedWriter bw1 = new BufferedWriter(new FileWriter(usedClauseFile, true));
                                                    for (int n = 0; n < usedClaId.size(); ++n) {
                                                        bw1.append(usedClaId.get(n) + "\n");
                                                    }
                                                    bw1.close();
                                                }
                                                
                                                String sourceLine = "";
                                                String saveScsClaLine = "";
                                                boolean permitOutput = false;
                                                BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(outFileName), "UTF8"));
                                                BufferedWriter bw = new BufferedWriter(new FileWriter(validOutFileName, true));
                                                while ((sourceLine = br.readLine()) != null) {
                                                    if (sourceLine.contains("%")) {
                                                        saveScsClaLine += sourceLine + "\n";
                                                    } else if (sourceLine.contains("cnf")) {
                                                        String claId = sourceLine.substring(sourceLine.indexOf("(") + 1, sourceLine.indexOf(","));
                                                        if (resRFindStr(usedClaId, claId)) {
                                                            saveScsClaLine += sourceLine + "\n";
                                                            permitOutput = true;
                                                            continue;
                                                        } else {
                                                            permitOutput = false;
                                                        }
                                                    }
                                                    if (permitOutput) {
                                                        saveScsClaLine += sourceLine + "\n";
                                                    }
                                                }
                                                br.close();
                                                bw.append(saveScsClaLine);
                                                bw.append(outStream);
                                                bw.flush();
                                                bw.close();
                                                System.out.println("%-------------------------------------------");
                                                System.out.println("% File        :CSE_E---1.1");
                                                System.out.println("% Problem     :" + problemName);
                                                System.out.println("% Transform   :fof cnf");
                                                System.out.println("% Format      :tptp:raw");
                                                System.out.println("% Command     :java -jar mcs_epr.jar CSE_E 0 0 2 1 %d %s");
                                                System.out.println("\n");
                                                System.out.println("% Result      :Theorem " + totalTime + "s");
                                                System.out.println("% Output      :CNFRefutation " + totalTime + "s");
                                                System.out.println("\n");
                                                Scanner scFof = new Scanner(files[i]);
                                                while (scFof.hasNextLine()) {
                                                    System.out.println(scFof.nextLine());
                                                }
                                                scFof.close();
                                                System.out.println("%-------------------------------------------");
                                                System.out.println("% Proof found");
                                                System.out.println("% SZS status Theorem " + problemName);
                                                System.out.println("% SZS output start Proof");
                                                String cnfFile = outTopFilePath + File.separator + problemNameNoSuffix + ".pre";
                                                File cnfFilePath = new File(cnfFile);
                                                if (cnfFilePath.exists()) {
                                                    Scanner scCnf = new Scanner(cnfFilePath);
                                                    while (scCnf.hasNextLine()) {
                                                        System.out.println(scCnf.nextLine());
                                                    }
                                                    scCnf.close();
                                                }
                                                System.out.println("%-------------------------------------------");
                                                
                                                Scanner scOutput = new Scanner(new File(validOutFileName));
                                                while (scOutput.hasNextLine()) {
                                                    System.out.println(scOutput.nextLine());
                                                }
                                                scOutput.close();
                                                System.out.println("% SZS output end Proof");
                                                System.out.println("% Total time :"+ totalTime + "s");
                                               
                                                String proofStatisticsInfo = problemNameNoSuffixFof + ":" + totalTime;
                                                insertContext(proofStatisticsInfo, proofStatisticsFile);
                                                continue;
                                            } else {
                                                String proofStatisticsInfo = problemNameNoSuffixFof + " :TMO‑Non";
                                                insertContext(proofStatisticsInfo, proofStatisticsFile);
                                                File file = new File(workPath);
                                                if (file.exists()) {
                                                    deleteDir(file);
                                                }
                                                File fileOur = new File(ourWorkPath);
                                                if (fileOur.exists()) {
                                                    deleteDir(fileOur);
                                                }
                                                System.out.println("TMO‑Non");
                                                continue;
                                            }
                                        } catch (Exception e) {
                                            e.printStackTrace();
                                        }
                                    } else {
                                        String proofStatisticsInfo = problemNameNoSuffixFof + " :TMO‑Non";
                                        insertContext(proofStatisticsInfo, proofStatisticsFile);
                                        File file = new File(workPath);
                                        if (file.exists()) {
                                            deleteDir(file);
                                        }
                                        File fileOur = new File(ourWorkPath);
                                        if (fileOur.exists()) {
                                            deleteDir(fileOur);
                                        }
                                        System.out.println("TMO‑Non");
                                        continue;
                                    }
                                }

                            }
                        }
                    }
                }
            }
            
        }
        else if(runMode == 1){
            
        }
        if (!submit) {
            String resultFilePath = getAppPath() + File.separator + "/proofStatistics.txt";
            if ((new File(resultFilePath)).exists()) {
                try {
                    String sourceLine = "";
                    int convertFail = 0;
                    int timeOut = 0;
                    int proofAll = 0;
                    int solveNumber = 0;
                    BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(resultFilePath), "UTF8"));
                    while ((sourceLine = br.readLine()) != null) {
                        if (sourceLine.contains("TMO‑Non")) {
                            ++timeOut;
                        } else if (sourceLine.contains("UNK‑Non")) {
                            ++convertFail;
                        }
                        ++proofAll;
                    }
                    br.close();
                    solveNumber = proofAll - timeOut - convertFail;
                    System.out.println("total numbers:" + proofAll + "  solver numbers:" + solveNumber + "   timeout numbers:" + timeOut + "   convertFailNumbers:" + convertFail);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }
    
}
